//: C05:Exercise4.cpp {-xo}
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
class Neporovnatelene {};

struct PrisnaLogika {
  Neporovnatelene nc1, nc2;
  void compare() {
    return nc1 == nc2; // Chyba překladu
  }
};

template<class T> struct MirnaLogika {
  Neporovnatelene nc1, nc2;
  void noOp() {}
  void compare() {
    nc1 == nc2;
  }
};

int main() {
  MirnaLogika<Neporovnatelene> l;
  l.noOp();
} ///:~
